class SushiNet::StoreBanner < Borges::Component

  attr_writer :frame

  def initialize(frame)
    @frame = frame
    @search_text = ''
  end

  def render_banner_on(r)
    r.div_named('title', title)
    r.div_named('subtitle', subtitle)
  end

  def render_content_on(r)
    r.title(title)
    r.table do
      r.table_row do
        r.element_id('search')
        r.table_data do render_search_on(r) end

        r.element_id('banner')
        r.table_data do render_banner_on(r) end
      end
    end
  end

  def render_search_on(r)
    r.form do
      r.small do
        r.bold('Search: ')
        r.text_input('') do |v| @search_text = v end
        r.default_action do search end
      end
    end
  end

  def search
    @frame.search(@search_text)
  end

  def subtitle
    return 'Fresh, raw fish delivered to your door'
  end

  def title
    return 'sushiNet'
  end

end

