class SushiNet::StoreCart < Borges::Component

  def remove(item)
    session.cart.delete(item)
  end

  def render_content_on(r)
    return self unless session.has_cart?

    r.div_named('cart') do
      r.small do r.bold('Your cart: ') end

      r.table do
        session.cart.each do |item, count| 
          render_row_for_count_on(count, item, r)
        end

        r.table_spacer_row

        r.table_row_with('')
        r.table_row_with('')
        r.table_row_with do
          r.bold do
            sum = 0
            session.cart.each do |item, count|
              sum += (item.price * count)
            end
            sum.to_cents
          end
        end
      end
    end
  end

  def render_row_for_count_on(count, item, r)
    if count == 1 then
      ''
    else
      "(#{count}) "
    end

    r.table_row_with do
      r.anchor('-') do
        remove(item)
      end
    end

    r.table_row_with("#{count} #{item.title}")
    r.table_row_with((count * item.price).to_cents)
  end

end

